// BlitManager.h: interface for the BlitManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BLITMANAGER_H__2AD7D1D1_ECF1_4779_B147_598AF5F61AAA__INCLUDED_)
#define AFX_BLITMANAGER_H__2AD7D1D1_ECF1_4779_B147_598AF5F61AAA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <d3d9.h>
#include <d3dx9.h>
#include <list>

#define MIN_BUFFER_SIZE	10

class BlitManager  
{
protected:
	struct Vertex
	{
		D3DXVECTOR3	p;
		DWORD		color;
		float		u,v;
	};
	struct Quad
	{
		Vertex	vertex[4];
	};
	struct BlitGroup
	{
		long					texture_id;
		long					number;
		long					index;
		LPDIRECT3DVERTEXBUFFER9	vertex_buffer;
		LPDIRECT3DINDEXBUFFER9	index_buffer;
		long					vallocated;
		long					iallocated;
		void*					vptr;
		WORD*					iptr;
	};
	typedef std::list<BlitGroup*>	BlitGroups;
public:
	BlitManager(LPDIRECT3DDEVICE9 device);
	virtual ~BlitManager();

	void	add(long texture,float x,float y,float z,float sx,float sy,float r,float g,float b,float a);
	void	add(long texture,D3DXVECTOR3& p,D3DXVECTOR2& hotspot,float angle,float sx,float sy,float r,float g,float b,float a);
	void	render();
	void	clear();
	void	clear_cache();

protected:
	LPDIRECT3DVERTEXBUFFER9	create_vertex_buffer(long size);
	void*					lock_vertex_buffer(LPDIRECT3DVERTEXBUFFER9 buffer);
	void					unlock_vertex_buffer(LPDIRECT3DVERTEXBUFFER9 buffer);
	LPDIRECT3DINDEXBUFFER9	create_index_buffer(long size);
	WORD*					lock_index_buffer(LPDIRECT3DINDEXBUFFER9 buffer);
	void					unlock_index_buffer(LPDIRECT3DINDEXBUFFER9 buffer);
	BlitGroup*				get_blit_group(long texture);

protected:
	LPDIRECT3DDEVICE9	_device;
	BlitGroups			_blits;
};

extern BlitManager* BLIT;

#endif // !defined(AFX_BLITMANAGER_H__2AD7D1D1_ECF1_4779_B147_598AF5F61AAA__INCLUDED_)
