// Drawable.h: interface for the Drawable class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRAWABLE_H__BEB0C095_88E8_44DA_9F2A_1CA800247BED__INCLUDED_)
#define AFX_DRAWABLE_H__BEB0C095_88E8_44DA_9F2A_1CA800247BED__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include <d3dx9.h>

typedef enum { BLEND_NONE, BLEND_ALPHA, BLEND_ADD } BlendMode;

class Drawable  
{
public:
	Drawable();
	virtual ~Drawable();

	virtual	void	draw() = 0;
	virtual void	anim() = 0;

	// Query
	inline	void		set_pos(float x,float y,float z) { _pos.x=x; _pos.y=y; _pos.z=z; }
	inline	D3DXVECTOR3	get_pos() { return _pos; }
	inline	float		get_x_pos() { return _pos.x; }
	inline	float		get_y_pos() { return _pos.y; }
	inline	float		get_z_pos() { return _pos.z; }

	// Settings
	inline	void	set_image(long img) { _current_image=img; }

	inline	void	set_priority(float priority) { _priority=priority; }
	inline	float	get_priority() { return _priority; }

	inline	void	set_blend_mode(BlendMode bm) { _blend_mode=bm; }

	inline	void	set_draw(bool b) { _draw=b; }

protected:
	D3DXVECTOR3	_pos;
	float		_last_frame_time;
	long		_current_image;
	float		_priority;
	bool		_draw;
	BlendMode	_blend_mode;
};

typedef std::vector<Drawable*>	Drawables;

#endif // !defined(AFX_DRAWABLE_H__BEB0C095_88E8_44DA_9F2A_1CA800247BED__INCLUDED_)
