#include "MouseCursor.h"
#include "TextureManager.h"
#include "Gfx.h"

MouseCursor*	CURSOR=NULL;

MouseCursor::MouseCursor(void)
{
	_pos.z=0.1f;
	set_image(TEXTURES->find_by_name("Cursor"));
	set_hotspot(32,32);
	CURSOR=this;

	set_priority(-1000.0f);
}

MouseCursor::~MouseCursor(void)
{
	CURSOR=NULL;
}

void MouseCursor::anim()
{
	Sprite::anim();

	POINT pt;
	GetCursorPos(&pt);
	_pos.x=pt.x;
	_pos.y=pt.y;

	RECT	full, client;
	long	clientw, clienth;
	HWND	window=GFX->get_window();

	GetClientRect(window,&client);
	clientw=client.right;
	clienth=client.bottom;
	AdjustWindowRect(&client,GFX->get_window_style(),false); 
	GetWindowRect(window,&full);

	RECT	e;
	e.left=full.left-client.left;
	e.top=full.top-client.top;
	e.right=full.left-client.left+clientw;
	e.bottom=full.top-client.top + clienth;

	float	sx=e.right-e.left;
	float	sy=e.bottom-e.top;

	_pos.x=(GFX->get_resolution().x)*(pt.x-e.left)/sx;
	_pos.y=(GFX->get_resolution().y)*(pt.y-e.top)/sy;
}
