// Screen.h: interface for the Screen class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCREEN_H__676B95DB_390F_4F6B_9405_CB63985E87C3__INCLUDED_)
#define AFX_SCREEN_H__676B95DB_390F_4F6B_9405_CB63985E87C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Drawable.h"

class Screen  
{
public:
	Screen();
	virtual ~Screen();

			long	run();
			void	run(float t);
	virtual void	render() = 0;
	virtual void	anim() = 0;
			
	inline	void	set_exit(bool b,long exit_code) { _exit=b; _exit_code=exit_code; }

	inline	void	add_drawable(Drawable* drawable) { _drawables.push_back(drawable); }
	inline	void	remove_drawable(Drawable* drawable) 
					{ 
						Drawables::iterator i; 
						for (i=_drawables.begin(); i!=_drawables.end(); ++i)
							if ((*i)==drawable) i=_drawables.erase(i); 
					}
			void	load_assets(std::string filename);

			bool	create_font();
			void	write_text(float x,float y,float r,float g,float b,float a,char *string);

	virtual	void	mouse_callback(unsigned long msg,unsigned long lparam,unsigned long uparam);

protected:
	bool			_exit;
	Drawables		_drawables;
	long			_exit_code;
	LPD3DXFONT		_font;
	LPD3DXSPRITE	_sprite;
	D3DXVECTOR2		_desktop_res;
};

extern Screen*	SCREEN;

#endif // !defined(AFX_SCREEN_H__676B95DB_390F_4F6B_9405_CB63985E87C3__INCLUDED_)
