// Sprite.h: interface for the Sprite class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPRITE_H__46CE9DE0_C822_4B18_8018_C1EC8E3F5214__INCLUDED_)
#define AFX_SPRITE_H__46CE9DE0_C822_4B18_8018_C1EC8E3F5214__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include <d3d9.h>
#include <d3dx9.h>
#include "Drawable.h"

class Sprite : public Drawable
{
protected:
	typedef std::vector<long>	Animation;
public:
	Sprite();
	Sprite(float x,float y,float z);
	virtual ~Sprite();

	inline	void	set_pos(float x,float y,float z) { _pos.x=x; _pos.y=y; _pos.z=z; }
	virtual void	anim();
	virtual	void	draw();
	
	inline	void	set_scale(float s) { _scale=s; }
	inline	float	get_scale() { return _scale; }
	inline	void	set_hotspot(float hx,float hy) { _hotspot.x=hx; _hotspot.y=hy; }
	inline	void	set_color(float r,float g,float b,float a) { _color=D3DXVECTOR4(r,g,b,a); }

	inline	float	get_x_hotspot() { return _hotspot.x; }
	inline	float	get_y_hotspot() { return _hotspot.y; }

	inline	void	set_angle(float ang) { _angle=(ang>360)?(ang-360):(ang); }
	inline	float	get_angle() { return _angle; }
	// Animation commands
	inline	void	add_animation_frame(long i) { _animation_frames.push_back(i); }
	inline	void	set_animation_loop(bool b) { _animation_loop=b; }
	inline	void	set_animation_rate(float rate) { _animation_rate=rate; }

protected:
	D3DXVECTOR2	_hotspot;
	float		_scale;
	float		_animation_last_frame_time;
	Animation	_animation_frames;
	float		_animation_rate;
	bool		_animation_loop;
	D3DXVECTOR4	_color;
	float		_angle;
};

#endif // !defined(AFX_SPRITE_H__46CE9DE0_C822_4B18_8018_C1EC8E3F5214__INCLUDED_)
