
#ifndef __UTILS_H
#define __UTILS_H

#define ERROR_MSG(X) MessageBox(NULL,X,"Swarm",MB_ICONERROR|MB_OK)

inline float get_random_number(float min,float max)
{
	if (min==max) return min;

	float d=float(rand())/float(RAND_MAX);

	return d*(max-min)+min;
}

inline float sign(float n)
{
	return ((n<0.0f)?(-1.0f):((n>0.0f)?(1.0f):(0.0f)));
}

#define Sqr(X) ((X)*(X))

inline	unsigned long FtoDW(float f) { return *((unsigned long*)&f); }

#include <d3dx9.h>

const float PI_OVER_180 = 3.1415926535f / 180.0f;
const float PI_UNDER_180 = 180.0f / 3.1415926535f;

inline float deg_to_rad(const float ang) { return ang*PI_OVER_180; }
inline float rad_to_deg(const float ang) { return ang*PI_UNDER_180; }

inline	D3DXVECTOR3	rotate_point2d(D3DXVECTOR3& p,float angle)
{
	float c=cosf(deg_to_rad(angle));
	float s=sinf(deg_to_rad(angle));

	D3DXVECTOR3 ret;
	ret.x=p.x*c-p.y*s;
	ret.y=p.x*s+p.y*c;
	ret.z=p.z;

	return ret;
}

inline	float	get_rotation_angle(D3DXVECTOR2& v)
{
	float angle=rad_to_deg(acos(v.x));
	if (v.y<0.0f) angle=360-angle;

	return angle+90.0f;
}

#endif