#pragma once
#include "../Framework/Sprite.h"
#include <list>

typedef enum { ANT_WANDER, ANT_FOLLOW, ANT_GOTO, ANT_STOP, ANT_RETURN,
			   ANT_FLEE } AntState;

class Ant :
	public Sprite
{
protected:
	typedef std::list<D3DXVECTOR2>	GotoPosQueue;
public:
	Ant(float x,float y,float z);
	virtual ~Ant(void);

	virtual	void		anim();

			void		wander();
			void		go_to(float x,float y,float speed);
			void		stop();

			void		queue_goto();

	inline	AntState	get_state() { return _state; }

protected:
	AntState		_state;
	D3DXVECTOR2		_goto_pos;
	GotoPosQueue	_goto_queue;
	float			_speed;
};
