#include "../framework/TextureManager.h"
#include "../framework/Utils.h"
#include "../framework/BlitManager.h"
#include "../framework/Sound.h"
#include "../framework/ParticleSystem.h"

#include "AntEater.h"
#include "GameScreen.h"
#include "PhenoromeMap.h"

AntEater::AntEater()
{
	if (rand()%2==0)
	{
		if (rand()%2==0) _pos.x=get_random_number(-100.0f,0.0f);
		else _pos.x=get_random_number(1024.0f,1124.0f);
		_pos.y=get_random_number(0.0f,768.0f);
	}
	else
	{
		if (rand()%2==0) _pos.y=get_random_number(-100.0f,0.0f);
		else _pos.y=get_random_number(768.0f,868.0f);
		_pos.x=get_random_number(0.0f,1024.0f);
	}
	_pos.z=0.15f;
	add_animation_frame(TEXTURES->find_by_name("AntEater01"));
	add_animation_frame(TEXTURES->find_by_name("AntEater02"));
	add_animation_frame(TEXTURES->find_by_name("AntEater03"));
	add_animation_frame(TEXTURES->find_by_name("AntEater02"));
	set_animation_loop(true);
	set_animation_rate(200);
	set_priority(-50.0f);
	set_hotspot(64,64);
	_goto_pos.x=1024.0f-_pos.x;
	_goto_pos.y=768.0f-_pos.y;
	_goto_pos.z=_pos.z;
}

AntEater::~AntEater(void)
{
}

void AntEater::anim()
{
	Sprite::anim();

	D3DXVECTOR3 vec=_goto_pos-_pos;

	if ((Sqr(vec.x)+Sqr(vec.y)<100.0f))
	{
		GameScreen* scr=dynamic_cast<GameScreen*>(SCREEN);
		if (scr) scr->remove_ant_eater(this);
		SCREEN->remove_drawable(this);
		delete this;
		return;
	}

	D3DXVECTOR3 vec_norm;
	D3DXVec3Normalize(&vec_norm,&vec);

	_angle=get_rotation_angle(D3DXVECTOR2(vec_norm.x,vec_norm.y));

	_pos=_pos+vec_norm*0.5f;
}

void AntEater::draw()
{
	Sprite::draw();
}
