#include "../framework/TextureManager.h"
#include "../framework/Utils.h"
#include "../framework/BlitManager.h"
#include "../framework/Sound.h"
#include "../framework/ParticleSystem.h"

#include "AntHill.h"
#include "GameScreen.h"
#include "PhenoromeMap.h"

AntHill::AntHill(float x,float y,float z) : Sprite(x,y,z)
{
	set_image(TEXTURES->find_by_name("AntHill"));
	set_priority(-50.0f);
	set_hotspot(64,64);
	_food=0.0f;
}

AntHill::~AntHill(void)
{
}

void AntHill::drop_food()
{
	float prev_food=_food;
	_food+=25.0f;
	if (_food>=500.0f) 
	{
		_food=500.0f;
		if (prev_food<500.0f)
		{
			// Fireworks!
			ParticleSystem *part=new ParticleSystem;
			part->set_pos(_pos.x,_pos.y,_pos.z-0.1f);
			part->set_image(TEXTURES->find_by_name("ParticleRound"));
			part->set_life(500.0f);
			part->set_rate(300.0f,200.0f);
			part->set_particle_life(900.0f,200.0f);
			part->set_particle_speed(0.0001f,0.00005f);
			part->set_particle_size(0.005f,0.02f);
			part->set_particle_color_start(1.0f,0.0f,0.0f,1.0f);
			part->set_particle_color_end(1.0f,1.0f,0.0f,0.2f);
			part->set_blend_mode(BLEND_ALPHA);
			SCREEN->add_drawable(part);
			// Sound
			SOUND->play(SOUND->find_by_name("HappyAnts"));
		}
	}
}

void AntHill::draw()
{
	if (!_draw) return;

	BLIT->add(TEXTURES->find_by_name("BarBackground"),
			  _pos.x-32.0f-32.0f,_pos.y-32.0f-16.0f,_pos.z-0.05f,
			  64,16,1,1,1,1);
	BLIT->add(TEXTURES->find_by_name("BarForeground"),
			  _pos.x-32.0f-32.0f+4.0f,_pos.y-32.0f-16.0f,_pos.z-0.07f,
			  54*(_food/500.0f)+1.0f,16,1,1,1,1);

	Sprite::draw();
}
