#include "../framework/TextureManager.h"
#include "../framework/Utils.h"
#include "../framework/BlitManager.h"
#include "../framework/Sound.h"
#include "../framework/ParticleSystem.h"

#include "Grasshoper.h"
#include "GameScreen.h"
#include "PhenoromeMap.h"

Grasshoper::Grasshoper()
{
	if (rand()%2==0) _pos.x=get_random_number(-100.0f,0.0f);
	else _pos.x=get_random_number(1024.0f,1124.0f);
	if (rand()%2==0) _pos.y=get_random_number(-100.0f,0.0f);
	else _pos.y=get_random_number(768.0f,868.0f);
	_pos.z=0.15f;
	set_image(TEXTURES->find_by_name("Grasshoper"));
	set_priority(-50.0f);
	set_hotspot(32,32);
	_goto_pos.x=1024.0f-_pos.x;
	_goto_pos.y=768.0f-_pos.y;
	_goto_pos.z=_pos.z;
}

Grasshoper::~Grasshoper(void)
{
}

void Grasshoper::anim()
{
	Sprite::anim();

	D3DXVECTOR3 vec=_goto_pos-_pos;

	if ((Sqr(vec.x)+Sqr(vec.y)<100.0f))
	{
		GameScreen* scr=dynamic_cast<GameScreen*>(SCREEN);
		if (scr) scr->remove_grasshoper(this);
		SCREEN->remove_drawable(this);
		delete this;
		return;
	}

	D3DXVECTOR3 vec_norm;
	D3DXVec3Normalize(&vec_norm,&vec);

	_angle=get_rotation_angle(D3DXVECTOR2(vec_norm.x,vec_norm.y));

	_pos=_pos+vec_norm*2.0f;
}

void Grasshoper::draw()
{
	if (!_draw) return;

	BLIT->add(TEXTURES->find_by_name("LeafShadow"),
			  _pos.x-32.0f,_pos.y,_pos.z+0.05f,
			  64,64,1,1,1,0.5f*_color.w);

	Sprite::draw();
}
